%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global provider        github
%global provider_tld    com
%global project         golang
%global repo            sys
# https://github.com/golang/sys
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     golang.org/x/sys
%global commit          ac6580df4449443a05718fd7858c1f91ad5f8d20
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-x-sys
Version:        0
Release:        0.29.20191215git%{shortcommit}%{?dist}.1
Summary:        Go packages for low-level interaction with the operating system
License:        BSD
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{commit}.tar.gz
Source1:        glide.yaml
Source2:        glide.lock
# Disable TestOpenByHandleAt which doesn't work in Mock chroot
Patch0:         golang-x-sys-Disable-TestOpenByHandleAt.patch

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 aarch64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}

%description
%{summary}

%package devel
Summary:       %{summary}
BuildArch:     noarch

Provides:      golang(%{import_path}/cpu) = %{version}-%{release}
Provides:      golang(%{import_path}/unix) = %{version}-%{release}
Provides:      golang(%{import_path}/windows) = %{version}-%{release}
Provides:      golang(%{import_path}/windows/registry) = %{version}-%{release}
Provides:      golang-ipath(golang.org/x/sys) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.

%prep
%setup -q -n %{repo}-%{commit}
%patch0 -p1
cp %{S:1} %{S:2} .

%build

%install
# source codes for building projects
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.s and generate devel.file-list
for file in $(find . -iname "*.s") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
# find all *.c and generate devel.file-list
for file in $(find . -iname "*.c") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done

sort -u -o devel.file-list devel.file-list
cp -p glide.* %{buildroot}/%{gopath}/src/%{import_path}/

%files devel -f devel.file-list
%license LICENSE PATENTS
%doc CONTRIBUTING.md README.md AUTHORS CONTRIBUTORS
%{gopath}/src/%{import_path}/glide.*

%changelog
* Tue Dec 17 16:43:49 CET 2019 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.29.20191215gitac6580d.1
- Fix typo in assembly files lookup
- Fix #1783684

* Sun Dec 15 20:24:34 CET 2019 Robert-André Mauchin <zebob.m@gmail.com> - 0-0.29.20191215gitac6580d
- Bump to commit ac6580df4449443a05718fd7858c1f91ad5f8d20
- Disable TestOpenByHandleAt test
- Fix #1783684
